<template>
	<div>
		<el-divider v-if="viajesPendientes.length > 0">Pendientes</el-divider>
			<template v-for="v in viajesPendientes" >
				<card-viaje :key="v.id" :model="v" 
					class="hover" :class="esReserva(v) ? 'reserva-vencida' : ''"
					:style="{ background:'#E6A23C60'}"
					draggable	@dragstart.native="dragStart($event, v.id)" @dragend.native="dragEnd($event)" 
					@mouseenter.native="itemHover = v.id"
					@mouseleave.native="itemHover = null">
					<template slot="actions" v-if="itemHover == v.id && !isDragging">
							<el-button type="primary" icon="el-icon-upload2" size="mini" @click="despacharViaje(v)" circle title="Despachar Viaje" />
							<el-button type="primary" icon="el-icon-edit" size="mini" circle @click="editarViaje(v)" title="Editar Viaje"/>
					</template>
				</card-viaje>
			</template>
		<el-divider v-if="viajesAsignados.length > 0">Asignados</el-divider>
			<template v-for="v in viajesAsignados" >
				<card-viaje :key="v.id" :model="v" 
					draggable	@dragstart.native="dragStart($event, v.id)" @dragend.native="dragEnd($event)" 
					@mouseenter.native="itemHover = v.id"
					@mouseleave.native="itemHover = null">
					<template slot="actions" v-if="itemHover == v.id && !isDragging">
							<el-button type="primary" icon="el-icon-upload2" size="mini" @click="despacharViaje(v)" circle title="Despachar Viaje" />
							<el-button type="primary" icon="el-icon-edit" size="mini" circle @click="editarViaje(v)" title="Editar Viaje"/>
					</template>
				</card-viaje>
			</template>
		<el-divider v-if="viajesReservados.length > 0">Reservas</el-divider>
			<template v-for="v in viajesReservados" >
				<card-viaje :key="v.id" :model="v" 
					draggable	@dragstart.native="dragStart($event, v.id)" @dragend.native="dragEnd($event)" 
					@mouseenter.native="itemHover = v.id"
					@mouseleave.native="itemHover = null">
					<template slot="actions" v-if="itemHover == v.id && !isDragging">
							<el-button type="primary" icon="el-icon-upload2" size="mini" @click="despacharViaje(v)" circle title="Despachar Viaje" />
							<el-button type="primary" icon="el-icon-edit" size="mini" circle @click="editarViaje(v)" title="Editar Viaje"/>
					</template>
				</card-viaje>
			</template>
		<el-divider v-if="viajesEnCurso.length > 0">En Curso</el-divider>
			<template v-for="v in viajesEnCurso" >
				<card-viaje :key="v.id" :model="v" 
					style="background:#F56C6C70"
					@mouseenter.native="itemHover = v.id"
					@mouseleave.native="itemHover = null">
					<template slot="actions" v-if="itemHover == v.id && !isDragging">
							<el-button type="primary" icon="el-icon-download" size="mini" @click="ingresarViaje(v)" circle title="Ingresar Viaje" />
							<el-button type="primary" icon="el-icon-edit" size="mini" circle @click="editarViaje(v)" title="Editar Viaje"/>
					</template>
				</card-viaje>
			</template>

		<el-dialog title="Viaje" :visible.sync="dialogoViaje" width="1024px" >
			<form-viaje embedded
				v-if="dialogoViaje"
				:idViaje="idViaje"
				@submit="dialogoViaje = false" @cancel="dialogoViaje=false"
				/>
		</el-dialog>
		<el-dialog title="Despachar Viaje" :visible.sync="dialogoDespacho" destroy-on-close>
			<viaje-despachar @submit="dialogoDespacho = false" v-if="dialogoDespacho" :id-viaje="idViaje" :idPlanilla="idPlanillaDespachar"/>
		</el-dialog>
		<el-dialog title="Ingresar Viaje" :visible.sync="dialogoIngreso" destroy-on-close>
			<viaje-finalizar @submit="dialogoIngreso = false" v-if="dialogoIngreso" :id-viaje="idViaje" />
		</el-dialog>
	</div>
	
</template>
<script>
import store from '@/store/viajes'
import storeLugares from '@/store/lugares'
// import storeCientes from '@/store/clientes'
import formViaje from './form-viaje'
import viajeDespachar from './viaje-despachar'
import viajeFinalizar from './viaje-finalizar'
import cardViaje from './card-viaje'

import {Rest} from '@/../modules/mind-core-vue/'

export default {
	components: {
		formViaje,
		viajeDespachar,
		cardViaje,
		viajeFinalizar
	},
	created(){
		store.idAgencia = 1

		this.api = new Rest({
			uri: `api/agencias/${store.idAgencia}/viajes`, 
			state: store.data,
			key: 'id'})
		this.fetchViajes()
		// this.setIntervalInstance = setInterval(() => {this.fetchViajes()}, 10000);
		this.setIntervalInstance = setInterval(this.fetchViajes, 60000);

		this.apiLugares = new Rest({
			uri: `api/agencias/${store.idAgencia}/lugares`, 
			state: storeLugares.data,
			key: 'id'})
			this.fetchLugares()

		// this.apiClientes = new Rest({
		// 	uri: `api/agencias/${store.idAgencia}/clientes`, 
		// 	state: storeCientes.data,
		// 	key: 'id'})
		// this.fetchClientes()


	},
	beforeDestroy() {
		clearInterval(this.setIntervalInstance)
	},
	computed: {
		viajesPendientes() {
			return store.data.RESOURCE_LIST.filter((v)=>{
				if(!v.fecha || !v.hora) {
					return v.estado == 'Pendiente'
				}
				const ahora = new Date()
				const tsViaje = new Date(`${v.fecha}T${v.hora}`) 
				const minutos = v.anticipacionReserva || 0
				const tsSalida = new Date(tsViaje.getTime() - minutos*60000);
				return tsSalida <= ahora && v.estado == 'Pendiente'
			})
		},
		viajesAsignados() {
			return store.data.RESOURCE_LIST.filter((v)=>{
				return v.estado == 'Asignado'
			})
		},
		viajesReservados() {
			return store.data.RESOURCE_LIST.filter((v)=>{
				// console.log(v.fecha, v.hora)
				const ahora = new Date()
				if(!v.fecha || !v.hora) {
					return false
				}
				const tsViaje = new Date(`${v.fecha}T${v.hora}`)
				const minutos = v.anticipacionReserva || 0
				const tsSalida = new Date(tsViaje.getTime() - minutos*60000);
				return tsSalida > ahora && v.estado == 'Pendiente'
			})
		},
		viajesEnCurso() {
			return store.data.RESOURCE_LIST.filter((v)=>{
				return v.estado == 'En Curso'
			})
		},
	},
	methods: {
		fetchViajes() {
			this.api.FetchAll({
				filters:{
					estado: ['Pendiente','En Curso', 'Reserva','Asignado']
				}
			}).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},
		editarViaje(viaje) {
			this.idViaje = viaje.id
			this.dialogoViaje = true;
		},
		despacharViaje(viaje) {
			this.idViaje = viaje.id
			this.dialogoDespacho = true
		},
		ingresarViaje(viaje) {
			this.idViaje = viaje.id
			this.dialogoIngreso = true
		},
		nuevoViaje() {
			this.idViaje = null
			this.dialogoViaje = true;
		},
		dragStart(event, idViaje) {
			this.isDragging = true
			event.dataTransfer.setData('idViaje', idViaje)
		},
		dragEnd() {
			this.isDragging = false
		},

		/**
		 * devuelve true si el viaje actual es una reserva
		 */
		esReserva(v) {
			return v.fecha && v.hora;
		},
		async fetchLugares() {
			this.apiLugares.FetchAll({
				filters: {
				},
				sort: ['tipo','nombre']
			}).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},
		async fetchClientes() {
			this.apiClientes.FetchAll({
				filters: {
				},
				sort: ['nombre']
			}).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},
	},
	data(){
		return{
			api: null,
			idViaje: null,
			idPlanillaDespachar: null,
			dialogoViaje: false,
			dialogoDespacho: false,
			dialogoIngreso: false,
			itemHover: false,
			isDragging: false,
			setIntervalInstance : null,
			apiClientes: null,
			apiLugares: null,
		}
	}
}
</script>

<style>
	.el-dialog  {
		margin-top: 10vh !important;
	}
	.el-dialog__body  {
		height: 70vh !important;
	}

</style>


<style scoped>



/* .el-button {
	position: ;
	top: 5px;
} */
.hover:hover {
	cursor:  grab;
}


.reserva-vencida {
  -webkit-animation: blink 3s infinite;  
  -moz-animation: blink 3s infinite;  
  -o-animation: blink 3s infinite;  
  animation: blink 3s infinite;  
}

@-webkit-keyframes blink {
  0%, 49% {
    /* background: red !important; */
		color: red;
  }
  50%, 100% {
    /* background: #e50000 !important; */
  }
}
</style>

